Index: CmdLineOptions.cxx
===================================================================
--- CmdLineOptions.cxx	(revision 20911)
+++ CmdLineOptions.cxx	(working copy)
@@ -68,8 +68,13 @@
 "[-d] "
 "[-density <num>] "
 "[-disableBots] "
-"[+f {good|<id>}] "
-"[-f {bad|<id>}] "
+//FIXME - DEPRECATED "[+f {good|<id>}] "
+//FIXME - DEPRECATED "[-f {bad|<id>}] "
+"[-fe <count>]"
+"[-ff <good|bad|team|<id>>[/count]]"
+"[-fr <good|bad|<id>>[/count]]"
+"[-frmax <count>]"
+"[-frtimes <min> <max>]"
 "[-fb] "
 "[-filterCallsigns] "
 "[-filterChat] "
@@ -119,8 +124,8 @@
 "[-reportfile <filename>] "
 "[-reportpipe <filename>] "
 "[-requireudp] "
-"[+s <flag-count>] "
-"[-s <flag-count>] "
+//FIXME - DEPRECATED "[+s <flag-count>] "
+//FIXME - DEPRECATED "[-s <flag-count>] "
 "[-sa] "
 "[-sb] "
 "[-set <name> <value>] "
@@ -170,9 +175,14 @@
 "\t-d: increase debugging level\n"
 "\t-density: specify building density for random worlds (default=5)\n"
 "\t-disableBots: disallow clients from using autopilot or robots\n"
-"\t+f: always have flag <id> available\n"
-"\t-f: never randomly generate flag <id>\n"
+//FIXME - DEPRECATED "\t+f: always have flag <id> available\n"
+//FIXME - DEPRECATED "\t-f: never randomly generate flag <id>\n"
 "\t-fb: allow flags on box buildings\n"
+"\t-fe: add extra flag slots\n"
+"\t-ff: add/delete forced flags\n"
+"\t-fr: add/delete random flags\n"
+"\t-frmax: set the maximum number of random flags on the field\n"
+"\t-frtimes: set the minimum and maximum random flag insertion delay times\n"
 "\t-filterCallsigns: filter callsigns to disallow inappropriate user names\n"
 "\t-filterChat: filter chat messages\n"
 "\t-filterSimple: perform simple exact matches with the bad word list\n"
@@ -222,8 +232,8 @@
 "\t-reportfile <filename>: the file to store reports in\n"
 "\t-reportpipe <filename>: the program to pipe reports through\n"
 "\t-requireudp: require clients to use udp\n"
-"\t+s: always have <num> super flags (default=16)\n"
-"\t-s: allow up to <num> super flags (default=16)\n"
+//FIXME - DEPRECATED "\t+s: always have <num> super flags (default=16)\n"
+//FIXME - DEPRECATED "\t-s: allow up to <num> super flags (default=16)\n"
 "\t-sa: insert antidote superflags\n"
 "\t-sb: allow tanks to respawn on buildings\n"
 "\t-set <name> <value>: set a BZDB variable's value\n"
@@ -545,7 +555,6 @@
 
 
 static bool accLimitSet = false;
-static bool allFlagsOut = false;
 
 void parse(int argc, char **argv, CmdLineOptions &options, bool fromWorldFile)
 {
@@ -664,59 +673,75 @@
       }
       debugLevel += count;
       // std::cout << "Debug level is now " << debugLevel << "" << std::endl;
+    } else if (strcmp(argv[i], "-fe") == 0) {
+      // extra flags
+      checkArgc(1, i, argc, argv[i]);
+      FLAGMGR.setExtraFlags(atoi(argv[i]));
+    } else if (strcmp(argv[i], "-ff") == 0) {
+      // forced flags
+      checkArgc(1, i, argc, argv[i]);
+      int count = 1;
+      char* slash = strchr(argv[i], '/');
+      if (slash != NULL) {
+        slash[0] = '\0'; // terminate
+        count = atoi(slash + 1);
+      }
+      if (!FLAGMGR.adjustForced(argv[i], count)) {
+        std::cerr << "invalid flag \"" << argv[i] << "\"" << std::endl;
+	usage(argv[0]);
+      }
+    } else if (strcmp(argv[i], "-fr") == 0) {
+      // random flags
+      checkArgc(1, i, argc, argv[i]);
+      int count = 1;
+      char* slash = strchr(argv[i], '/');
+      if (slash != NULL) {
+        slash[0] = '\0'; // terminate
+        count = atoi(slash + 1);
+      }
+      if (!FLAGMGR.adjustRandom(argv[i], count)) {
+        std::cerr << "invalid flag \"" << argv[i] << "\"" << std::endl;
+	usage(argv[0]);
+      }
+    } else if (strcmp(argv[i], "-frmax") == 0) {
+      // random flag minimum
+      checkArgc(1, i, argc, argv[i]);
+      FLAGMGR.setRandomMaximum(atoi(argv[i]));
+    } else if (strcmp(argv[i], "-frtimes") == 0) {
+      // random flag minimum
+      checkArgc(2, i, argc, argv[i]);
+      const float min = atof(argv[i]);
+      i++;
+      const float max = atof(argv[i]);
+      FLAGMGR.setRandomDelayTimes(min, max);
+/*
     } else if (strcmp(argv[i], "-f") == 0) {
-      // disallow given flag
+      // FIXME: DEPRECATED switch
       checkArgc(1, i, argc, argv[i]);
-      if (strcmp(argv[i], "bad") == 0) {
-	FlagSet badFlags = Flag::getBadFlags();
-	for (FlagSet::iterator it = badFlags.begin(); it != badFlags.end(); it++)
-	  options.flagDisallowed[*it] = true;
-      } else if (strcmp(argv[i], "good") == 0) {
-	FlagSet goodFlags = Flag::getGoodFlags();
-	for (FlagSet::iterator it = goodFlags.begin(); it != goodFlags.end(); it++)
-	  options.flagDisallowed[*it] = true;
-      } else {
-	FlagType* fDesc = Flag::getDescFromAbbreviation(argv[i]);
-	if (fDesc == Flags::Null) {
-	  std::cerr << "invalid flag \"" << argv[i] << "\"" << std::endl;
-	  usage(argv[0]);
-	}
-	options.flagDisallowed[fDesc] = true;
+      if (!FLAGMGR.forbidType(argv[i])) {
+        std::cerr << "invalid flag \"" << argv[i] << "\"" << std::endl;
+	usage(argv[0]);
       }
+*/
+/*
     } else if (strcmp(argv[i], "+f") == 0) {
-      // add required flag
+      // FIXME: DEPRECATED switch
       checkArgc(1, i, argc, argv[i]);
+      int count = 1;
 
       char *repeatStr = strchr(argv[i], '{');
-      int rptCnt = 1;
       if (repeatStr != NULL) {
 	*(repeatStr++) = 0;
-	rptCnt = atoi(repeatStr);
-	if (rptCnt <= 0)
-	  rptCnt = 1;
+	count = atoi(repeatStr);
+	if (count <= 0) {
+	  count = 1;
+        }
       }
-      if (strcmp(argv[i], "good") == 0) {
-	FlagSet goodFlags = Flag::getGoodFlags();
-	for (FlagSet::iterator it = goodFlags.begin(); it != goodFlags.end(); it++)
-	  options.flagCount[*it] += rptCnt;
-      } else if (strcmp(argv[i], "bad") == 0) {
-	FlagSet badFlags = Flag::getBadFlags();
-	for (FlagSet::iterator it = badFlags.begin(); it != badFlags.end(); it++)
-	  options.flagCount[*it] += rptCnt;
-      } else if (strcmp(argv[i], "team") == 0) {
-	for (int t = RedTeam; t <= PurpleTeam; t++)
-	  options.numTeamFlags[t] += rptCnt;
-      } else {
-	FlagType *fDesc = Flag::getDescFromAbbreviation(argv[i]);
-	if (fDesc == Flags::Null) {
-	  std::cerr << "invalid flag \"" << argv[i] << "\"" << std::endl;
-	  usage(argv[0]);
-	} else if (fDesc->flagTeam != NoTeam) {
-	  options.numTeamFlags[fDesc->flagTeam] += rptCnt;
-	} else {
-	  options.flagCount[fDesc] += rptCnt;
-	}
+      if (!FLAGMGR.adjustForced(argv[i], count)) {
+        std::cerr << "invalid flag \"" << argv[i] << "\"" << std::endl;
+	usage(argv[0]);
       }
+*/
     } else if (strcmp(argv[i], "-fb") == 0) {
       // flags on buildings
       options.flagsOnBuildings = true;
@@ -990,17 +1015,28 @@
     } else if (strcmp(argv[i], "-requireudp") == 0) {
       std::cerr << "require UDP clients!" << std::endl;
       options.requireUDP = true;
-    } else if (strcmp(argv[i], "+s") == 0 || strcmp(argv[i], "-s") == 0) {
-      // with +s all flags are required to exist all the time
-      allFlagsOut = argv[i][0] == '+' ? true : false;
+/*
+    } else if ((strcmp(argv[i], "-s") == 0) ||
+               (strcmp(argv[i], "+s") == 0)) {
+      // FIXME: DEPRECATED switches
+      int count = 16;
+      bool allOut = (argv[i][0] == '+');
       // set number of random flags
-      if (i+1 < argc && isdigit(argv[i+1][0])) {
-	++i;
-	if ((options.numExtraFlags = atoi(argv[i])) == 0)
-	  options.numExtraFlags = 16;
-      } else {
-	options.numExtraFlags = 16;
+      if (((i + 1) < argc) && isdigit(argv[i+1][0])) {
+	i++;
+	int tmp = atoi(argv[i]);
+	if (tmp != 0) {
+	  count = tmp;
+        }
       }
+      const int flagTypes = FlagType::getFlagMap().size();
+      FLAGMGR.clearRandomPool();
+      FLAGMGR.adjustRandom("all", 2 + (count / flagTypes));
+      FLAGMGR.setRandomMaximum(count);
+      if (allOut) {
+        FLAGMGR.setRandomDelayTimes(0.0f, 0.0f);
+      }
+*/
     } else if (strcmp(argv[i], "-sa") == 0) {
       // insert antidote flags
       options.gameStyle |= int(AntidoteGameStyle);
@@ -1026,6 +1062,7 @@
       i++;
       value = argv[i];
       BZDB.set(name, value);
+      BZDB.addCallback(name, onGlobalChanged, (void*)NULL);
       logDebugMessage(1,"set variable: %s = %s\n", name, BZDB.get(name).c_str());
     } else if (strcmp(argv[i], "-sl") == 0) {
       // add required flag
@@ -1201,68 +1238,21 @@
 }
 
 
-static int getZoneTeamFlagCount(FlagType* flagType, EntryZones& entryZones,
-				 const std::set<FlagType*>& forbidden)
+void finalizeParsing(int /*argc*/, char **argv, CmdLineOptions &options)
 {
-  if (forbidden.find(flagType) != forbidden.end()) {
-    return 0;
-  }
-  // tally zone team flags
-  int count = 0;
-  const ZoneList& zl = entryZones.getZoneList();
-  for (int z = 0; z < (int)zl.size(); z++) {
-    const ZoneFlagMap& zfm = zl[z].getZoneFlagMap();
-    ZoneFlagMap::const_iterator zfmIt;
-    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
-      if (zfmIt->first == flagType) {
-	count += zfmIt->second;
-      }
-    }
-  }
-  return count;
-}
-
-
-static int addZoneTeamFlags(int startIndex,
-			    FlagType* flagType, EntryZones& entryZones,
-			    const std::set<FlagType*>& forbidden)
-{
-  if (forbidden.find(flagType) != forbidden.end()) {
-    return startIndex;
-  }
-  // add zone team flags
-  const ZoneList& zl = entryZones.getZoneList();
-  for (int z = 0; z < (int)zl.size(); z++) {
-    const ZoneFlagMap& zfm = zl[z].getZoneFlagMap();
-    ZoneFlagMap::const_iterator zfmIt;
-    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
-      if (zfmIt->first == flagType) {
-	const int count = zfmIt->second;
-	for (int c = 0; c < count; c++) {
-	  entryZones.addZoneFlag(z, startIndex);
-	  FlagInfo::get(startIndex++)->setRequiredFlag(flagType);
-	}
-      }
-    }
-  }
-  return startIndex;
-}
-
-
-void finalizeParsing(int /*argc*/, char **argv,
-		     CmdLineOptions &options, EntryZones& entryZones)
-{
   if (options.flagsOnBuildings && !(options.gameStyle & JumpingGameStyle)) {
     std::cerr << "flags on boxes requires jumping" << std::endl;
     usage(argv[0]);
   }
 
+  // sanitize the team counts for rabbit modes
   if (options.gameStyle & int(RabbitChaseGameStyle)) {
     for (int j = RedTeam; j <= PurpleTeam; j++) {
-      if (options.maxTeam[j] > 0
-	  && options.maxTeam[RogueTeam] != maxRealPlayers)
+      if ((options.maxTeam[j] > 0) &&
+          (options.maxTeam[RogueTeam] != maxRealPlayers)) {
 	std::cout << "only rogues are allowed in Rabbit Style; zeroing out "
 		  << Team::getName((TeamColor) j) << std::endl;
+      }
       options.maxTeam[j] = 0;
     }
   }
@@ -1278,218 +1268,6 @@
 	   "affecting any players, including those using \"mouse enhancements\".\n");
   }
 
-
-  // do we have any team flags?
-  bool hasTeam = false;
-  for (int p = RedTeam; p <= PurpleTeam; p++) {
-    if (options.maxTeam[p] > 1) {
-      hasTeam = true;
-      break;
-    }
-  }
-
-  std::set<FlagType*> forbidden;
-  forbidden.insert(Flags::Null);
-
-  // first disallow flags inconsistent with game style
-  if (options.gameStyle & JumpingGameStyle) {
-    forbidden.insert(Flags::Jumping);
-  } else {
-    forbidden.insert(Flags::NoJumping);
-  }
-  if (options.gameStyle & RicochetGameStyle) {
-    forbidden.insert(Flags::Ricochet);
-  }
-  if (!options.useTeleporters && (options.worldFile == "")) {
-    forbidden.insert(Flags::PhantomZone);
-  }
-  if (!hasTeam) {
-    forbidden.insert(Flags::Genocide);
-    forbidden.insert(Flags::Colorblindness);
-    forbidden.insert(Flags::Masquerade);
-  }
-  if ((options.gameStyle & TeamFlagGameStyle) == 0) {
-    forbidden.insert(Flags::RedTeam);
-    forbidden.insert(Flags::GreenTeam);
-    forbidden.insert(Flags::BlueTeam);
-    forbidden.insert(Flags::PurpleTeam);
-  }
-  if (options.maxTeam[RedTeam] <= 0) {
-    forbidden.insert(Flags::RedTeam);
-  }
-  if (options.maxTeam[GreenTeam] <= 0) {
-    forbidden.insert(Flags::GreenTeam);
-  }
-  if (options.maxTeam[BlueTeam] <= 0) {
-    forbidden.insert(Flags::BlueTeam);
-  }
-  if (options.maxTeam[PurpleTeam] <= 0) {
-    forbidden.insert(Flags::PurpleTeam);
-  }
-
-  // void the forbidden flags
-  std::set<FlagType*>::const_iterator sit;
-  for (sit = forbidden.begin(); sit != forbidden.end(); sit++) {
-    FlagType* ft = *sit;
-    options.flagCount[ft] = 0;
-    options.flagDisallowed[ft] = true;
-  }
-
-  // zone team flag counts
-  const int zoneTeamFlagCounts[5] = {
-    0, // rogue
-    getZoneTeamFlagCount(Flags::RedTeam, entryZones, forbidden),
-    getZoneTeamFlagCount(Flags::GreenTeam, entryZones, forbidden),
-    getZoneTeamFlagCount(Flags::BlueTeam, entryZones, forbidden),
-    getZoneTeamFlagCount(Flags::PurpleTeam, entryZones, forbidden)
-  };
-
-  // make sure there is at least one team flag for each active team
-  if (options.gameStyle & TeamFlagGameStyle) {
-    for (int col = RedTeam; col <= PurpleTeam; col++) {
-      if ((options.maxTeam[col] > 0) &&
-	  (options.numTeamFlags[col] <= 0) &&
-	  (zoneTeamFlagCounts[col] <= 0)) {
-	options.numTeamFlags[col] = 1;
-      }
-    }
-  }
-
-  // make table of allowed extra flags
-  if (options.numExtraFlags > 0) {
-    // now count how many aren't disallowed
-    for (FlagTypeMap::iterator it = FlagType::getFlagMap().begin();
-	 it != FlagType::getFlagMap().end(); ++it) {
-      if (!options.flagDisallowed[it->second]) {
-	options.numAllowedFlags++;
-      }
-    }
-    // if none allowed then no extra flags either
-    if (options.numAllowedFlags == 0) {
-      options.numExtraFlags = 0;
-    } else {
-      // types of extra flags allowed
-      std::vector<FlagType*> allowedFlags;
-      allowedFlags.clear();
-      for (FlagTypeMap::iterator it = FlagType::getFlagMap().begin();
-	   it != FlagType::getFlagMap().end(); ++it) {
-	FlagType *fDesc = it->second;
-	if ((fDesc == Flags::Null) || (fDesc->flagTeam != ::NoTeam))
-	  continue;
-	if (!options.flagDisallowed[it->second])
-	  allowedFlags.push_back(it->second);
-      }
-      // Loading allowedFlags vector
-      FlagInfo::setAllowed(allowedFlags);
-    }
-  }
-
-  const ZoneList& zl = entryZones.getZoneList();
-
-  // allocate space for extra flags
-  numFlags = options.numExtraFlags;
-  // allocate space for team flags
-  if (options.gameStyle & TeamFlagGameStyle) {
-    for (int col = RedTeam; col <= PurpleTeam; col++) {
-      if (options.maxTeam[col] > 0) {
-	numFlags += options.numTeamFlags[col];
-      }
-    }
-  }
-  // allocate space for normal flags
-  for (FlagTypeMap::iterator it = FlagType::getFlagMap().begin();
-       it != FlagType::getFlagMap().end(); ++it) {
-    numFlags += options.flagCount[it->second];
-  }
-  // allocate space for zone flags (including teams flags)
-  for (int z = 0; z < (int)zl.size(); z++) {
-    const CustomZone& zone = zl[z];
-    const ZoneFlagMap& zfm = zone.getZoneFlagMap();
-    ZoneFlagMap::const_iterator zfmIt;
-    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
-      if (forbidden.find(zfmIt->first) == forbidden.end()) {
-	numFlags += zfmIt->second;
-      }
-    }
-  }
-
-  FlagInfo::setSize(numFlags);
-
-  // add team flags (ordered)
-  int f = 0;
-  if (options.gameStyle & TeamFlagGameStyle) {
-    if (options.maxTeam[RedTeam] > 0) {
-      f = addZoneTeamFlags(f, Flags::RedTeam, entryZones, forbidden);
-      for (int n = 0; n < options.numTeamFlags[RedTeam]; n++) {
-	FlagInfo::get(f++)->setRequiredFlag(Flags::RedTeam);
-      }
-    }
-    if (options.maxTeam[GreenTeam] > 0) {
-      f = addZoneTeamFlags(f, Flags::GreenTeam, entryZones, forbidden);
-      for (int n = 0; n < options.numTeamFlags[GreenTeam]; n++) {
-	FlagInfo::get(f++)->setRequiredFlag(Flags::GreenTeam);
-      }
-    }
-    if (options.maxTeam[BlueTeam] > 0) {
-      f = addZoneTeamFlags(f, Flags::BlueTeam, entryZones, forbidden);
-      for (int n = 0; n < options.numTeamFlags[BlueTeam]; n++) {
-	FlagInfo::get(f++)->setRequiredFlag(Flags::BlueTeam);
-      }
-    }
-    if (options.maxTeam[PurpleTeam] > 0) {
-      f = addZoneTeamFlags(f, Flags::PurpleTeam, entryZones, forbidden);
-      for (int n = 0; n < options.numTeamFlags[PurpleTeam]; n++) {
-	FlagInfo::get(f++)->setRequiredFlag(Flags::PurpleTeam);
-      }
-    }
-  }
-
-  // super flags?
-  if (f < numFlags) {
-    options.gameStyle |= int(SuperFlagGameStyle);
-  }
-
-  // add normal flags
-  for (FlagTypeMap::iterator it2 = FlagType::getFlagMap().begin();
-       it2 != FlagType::getFlagMap().end(); ++it2) {
-    FlagType *fDesc = it2->second;
-
-    if ((fDesc != Flags::Null) && (fDesc->flagTeam == NoTeam)) {
-      for (int j = 0; j < options.flagCount[fDesc]; j++) {
-	FlagInfo::get(f++)->setRequiredFlag(fDesc);
-      }
-    }
-  }
-  // add zone flags
-  for (int z = 0; z < (int)zl.size(); z++) {
-    const CustomZone& zone = zl[z];
-    const ZoneFlagMap& zfm = zone.getZoneFlagMap();
-    ZoneFlagMap::const_iterator zfmIt;
-    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
-      FlagType* ft = zfmIt->first;
-      if ((ft->flagTeam == ::NoTeam) && // no team flags here
-	  (forbidden.find(ft) == forbidden.end())) {
-	const int count = zfmIt->second;
-	for (int c = 0; c < count; c++) {
-	  entryZones.addZoneFlag(z, f);
-	  FlagInfo::get(f++)->setRequiredFlag(ft);
-	}
-      }
-    }
-  }
-  // add extra flags
-  for (; f < numFlags; f++) {
-    FlagInfo::get(f)->required = allFlagsOut;
-  }
-
-  // sum the sources of team flags
-  if (options.gameStyle & TeamFlagGameStyle) {
-    for (int col = RedTeam; col <= PurpleTeam; col++) {
-      options.numTeamFlags[col] += zoneTeamFlagCounts[col];
-    }
-  }
-
-
   // debugging
   logDebugMessage(1,"style: %x\n", options.gameStyle);
   if (options.gameStyle & int(TeamFlagGameStyle))
Index: RandomSpawnPolicy.cxx
===================================================================
--- RandomSpawnPolicy.cxx	(revision 20911)
+++ RandomSpawnPolicy.cxx	(working copy)
@@ -48,15 +48,14 @@
   const PlayerInfo& pi = playerData->player;
   TeamColor t = pi.getTeam();
 
-  if (!BZDB.isTrue("freeCtfSpawns") &&
-      playerData->player.shouldRestartAtBase() &&
-      (t >= RedTeam) && (t <= PurpleTeam) &&
-      (bases.find(t) != bases.end())) {
+  if (!BZDB.isTrue("freeCtfSpawns")
+      && playerData->player.shouldRestartAtBase()
+      && (t >= RedTeam) && (t <= PurpleTeam)
+      && (bases.find(t) != bases.end())) {
 
     /* if the player needs to spawn on a base, select a random
      * position on one of their team's available bases.
      */
-
     TeamBases &teamBases = bases[t];
     const TeamBase &base = teamBases.getRandomBase((int)(bzfrand() * 100));
     base.getRandomPosition(pos[0], pos[1], pos[2]);
Index: EntryZones.cxx
===================================================================
--- EntryZones.cxx	(revision 20911)
+++ EntryZones.cxx	(working copy)
@@ -41,23 +41,6 @@
 }
 
 
-void EntryZones::addZoneFlag(int zone, int flagId)
-{
-  if (zone >= (int)zones.size()) {
-    printf ("Internal error: EntryZones::addZoneFlag() unknown zone\n");
-    exit(1);
-  }
-  const std::string& qualifier = CustomZone::getFlagIdQualifier(flagId);
-  QPairList &qPairList = qmap[qualifier];
-  if (qPairList.size() > 0) {
-    printf ("Internal error: EntryZones::addZoneFlag() duplicate\n");
-    exit(1);
-  }
-  qPairList.push_back(std::pair<int,float>(zone, 1.0f));
-  return;
-}
-
-
 void EntryZones::calculateQualifierLists()
 {
   // generate the qualifier lists
@@ -209,7 +192,7 @@
 
 
 void EntryZones::makeSplitLists (int zone,
-				 std::vector<FlagType*> &flags,
+				 std::vector<const FlagType*> &flags,
 				 std::vector<TeamColor> &teams,
 				 std::vector<TeamColor> &safety) const
 {
@@ -227,7 +210,7 @@
       if (zoneIndex == zone) {
 	const std::string& qual = mit->first;
 	int team;
-	FlagType *type;
+	const FlagType *type;
 	if ((type = CustomZone::getFlagTypeFromQualifier(qual)) != Flags::Null) {
 	  flags.push_back(type);
 	}
@@ -254,7 +237,7 @@
 
   for (unsigned int i = 0; i < zones.size(); i++) {
     const WorldFileLocation& z = (const WorldFileLocation) zones[i];
-    std::vector<FlagType*> flags;
+    std::vector<const FlagType*> flags;
     std::vector<TeamColor> teams;
     std::vector<TeamColor> safety;
     makeSplitLists (i, flags, teams, safety);
@@ -284,7 +267,7 @@
   fullSize += sizeof(uint32_t); // zone count
 
   for (unsigned int i = 0; i < zones.size(); i++) {
-    std::vector<FlagType*> flags;
+    std::vector<const FlagType*> flags;
     std::vector<TeamColor> teams;
     std::vector<TeamColor> safety;
     makeSplitLists (i, flags, teams, safety);
Index: FlagHistory.cxx
===================================================================
--- FlagHistory.cxx	(revision 20911)
+++ FlagHistory.cxx	(working copy)
@@ -25,10 +25,10 @@
 
 void FlagHistory::get(char message[]) {
     char flag[MessageLen];
-    std::vector<FlagType*>::iterator fhIt = flagHistory.begin();
+    std::vector<const FlagType*>::iterator fhIt = flagHistory.begin();
 
     while (fhIt != flagHistory.end()) {
-      FlagType * fDesc = (FlagType*)(*fhIt);
+      const FlagType * fDesc = (const FlagType*)(*fhIt);
       if (fDesc->endurance == FlagNormal)
 	sprintf(flag, "(*%c) ", fDesc->flagName[0]);
       else
@@ -38,7 +38,7 @@
     }
 }
 
-void FlagHistory::add(FlagType* type) {
+void FlagHistory::add(const FlagType* type) {
   if (flagHistory.size() >= MAX_FLAG_HISTORY)
     flagHistory.erase(flagHistory.begin());
   flagHistory.push_back(type);
Index: bzfsAPI.cxx
===================================================================
--- bzfsAPI.cxx	(revision 20911)
+++ bzfsAPI.cxx	(working copy)
@@ -708,14 +708,14 @@
   playerRecord->rot = player->lastState.azimuth;
 
   int flagid = player->player.getFlag();
-  FlagInfo *flagInfo = FlagInfo::get(flagid);
+  FlagInfo *flagInfo = FLAGMGR.getFlag(flagid);
 
   std::string label;
-  if (flagInfo && flagInfo->flag.type)
-    label = flagInfo->flag.type->label();
+  if (flagInfo && flagInfo->getFlagType())
+    label = flagInfo->getFlagType()->label();
   playerRecord->currentFlag = label;
 
-  std::vector<FlagType*>	flagHistoryList = player->flagHistory.get();
+  std::vector<const FlagType*> flagHistoryList = player->flagHistory.get();
 
   playerRecord->flagHistory.clear();
   for ( unsigned int i = 0; i < flagHistoryList.size(); i ++)
@@ -861,11 +861,11 @@
   if (!player)
     return NULL;
 
-  FlagInfo* flagInfo = FlagInfo::get(player->player.getFlag());
+  FlagInfo* flagInfo = FLAGMGR.getFlag(player->player.getFlag());
   if (!flagInfo)
     return NULL;
 
-  return FlagInfo::get(player->player.getFlag())->flag.type->flagAbbv;
+  return FLAGMGR.getFlag(player->player.getFlag())->getFlagType()->flagAbbv;
 }
 
 BZF_API bool bz_isPlayerPaused( int playerID )
@@ -1624,13 +1624,13 @@
       // find unused and forced candidates
       FlagInfo* unused = NULL;
       FlagInfo* forced = NULL;
-      for (int i = 0; i < numFlags; i++)
+      for (int i = 0; i < FLAGMGR.size(); i++)
       {
-	FlagInfo* fi2 = FlagInfo::get(i);
-	if ((fi2 != NULL) && (fi2->flag.type == ft))
+	FlagInfo* fi2 = FLAGMGR.getFlag(i);
+	if ((fi2 != NULL) && (fi2->getFlagType() == ft))
 	{
 	  forced = fi2;
-	  if (fi2->player < 0)
+	  if (fi2->getPlayer() < 0)
 	  {
 	    unused = fi2;
 	    break;
@@ -1673,8 +1673,8 @@
     const int flagId = gkPlayer->player.getFlag();
     if (flagId >= 0)
     {
-      FlagInfo& currentFlag = *FlagInfo::get(flagId);
-      if (currentFlag.flag.type->flagTeam != NoTeam)
+      FlagInfo& currentFlag = *FLAGMGR.getFlag(flagId);
+      if (currentFlag.getTeamIndex() != NoTeam)
 	dropFlag(currentFlag, gkPlayer->lastState.pos);// drop team flags
       else
 	resetFlag(currentFlag);// reset non-team flags
@@ -1712,11 +1712,11 @@
 
 BZF_API void bz_resetFlags ( bool onlyUnused )
 {
-  for (int i = 0; i < numFlags; i++)
+  for (int i = 0; i < FLAGMGR.size(); i++)
   {
-    FlagInfo &flag = *FlagInfo::get(i);
+    FlagInfo &flag = *FLAGMGR.getFlag(i);
     // see if someone had grabbed flag,
-    const int playerIndex = flag.player;
+    const int playerIndex = flag.getPlayer();
     if (!onlyUnused || (playerIndex == -1))
     {
       if (playerIndex != -1)
@@ -1730,26 +1730,26 @@
 
 BZF_API unsigned int bz_getNumFlags( void )
 {
-  return numFlags;
+  return FLAGMGR.size();
 }
 
 BZF_API const bzApiString bz_getName( int flag )
 {
-  FlagInfo *pFlag = FlagInfo::get(flag);
+  FlagInfo *pFlag = FLAGMGR.getFlag(flag);
   if (!pFlag)
     return bzApiString("");
 
-  return bzApiString(pFlag->flag.type->flagAbbv);
+  return bzApiString(pFlag->getFlagType()->flagAbbv);
 }
 
 BZF_API bool bz_resetFlag ( int flag )
 {
-  FlagInfo *pFlag = FlagInfo::get(flag);
+  FlagInfo *pFlag = FLAGMGR.getFlag(flag);
   if(!pFlag)
     return false;
 
   // if somone has it, drop it
-  if (pFlag->player != -1)
+  if (pFlag->getPlayer() != -1)
     sendDrop(*pFlag);
 
   resetFlag(*pFlag);
@@ -1759,15 +1759,15 @@
 
 BZF_API bool bz_moveFlag ( int flag, float pos[3] )
 {
-  FlagInfo *pFlag = FlagInfo::get(flag);
+  FlagInfo *pFlag = FLAGMGR.getFlag(flag);
   if(!pFlag)
     return false;
 
   // if somone has it, drop it
-  if (pFlag->player != -1)
+  if (pFlag->getPlayer() != -1)
     sendDrop(*pFlag);
 
-  int teamIndex = pFlag->teamIndex();
+  int teamIndex = pFlag->getTeamIndex();
   bool teamIsEmpty = true;
   if (teamIndex != ::NoTeam)
     teamIsEmpty = (team[teamIndex].team.size == 0);
@@ -1780,22 +1780,22 @@
 
 BZF_API int bz_flagPlayer ( int flag )
 {
-  FlagInfo *pFlag = FlagInfo::get(flag);
+  FlagInfo *pFlag = FLAGMGR.getFlag(flag);
   if(!pFlag)
     return -1;
 
-  return pFlag->player;
+  return pFlag->getPlayer();
 }
 
 BZF_API bool bz_getFlagPosition ( int flag, float* pos )
 {
-  FlagInfo *pFlag = FlagInfo::get(flag);
+  FlagInfo *pFlag = FLAGMGR.getFlag(flag);
   if(!pFlag || !pos)
     return false;
 
-  if (pFlag->player != -1)
+  if (pFlag->getPlayer() != -1)
   {
-    GameKeeper::Player *player = GameKeeper::Player::getPlayerByIndex(pFlag->player);
+    GameKeeper::Player *player = GameKeeper::Player::getPlayerByIndex(pFlag->getPlayer());
 
     if (!player)
       return false;
@@ -1803,7 +1803,7 @@
     memcpy(pos,player->lastState.pos,sizeof(float)*3);
   }
   else
-    memcpy(pos,pFlag->flag.position,sizeof(float)*3);
+    memcpy(pos,pFlag->getFlag().position,sizeof(float)*3);
 
   return true;
 }
